package it.m2.net.telnet;
import java.io.IOException;

/**
 * Interface to handle telnet option
 *
 * @author Mario Viara
 * @version $Id: TelnetOptionHandler.java,v 1.1.1.1 2004/06/22 11:29:09 mviara Exp $
 */
interface TelnetOptionHandler
{
	/**
	 * Invoked when the option chane state
	 *
	 * @parameter telnet Telnet ownner
	 * @parameter option Telnet option number
	 * @parameter locale true if is local option false if is remote
	 * option
	 * @parameter oldState Old state of the option
	 * @parameter newState New state of the option
	 */
	public void setDo(Telnet telnet,int option,boolean oldState,boolean newState);

	public void setWill(Telnet telnet,int option,boolean oldState,boolean newState);

	/**
	 * Invoke when telnet sub negotiation is necessary
	 *
	 * @parameter telnet Telnet ownner
	 * @parameter option Telnet option number
	 * @parameter locale true if is local option false if is remote
	 * option
	 * @parameter sbLenght lenght of the sub option received
	 * @parameter sbBuffer buffer with the sub option received.
	 */
	public void		sb(Telnet telnet,int option,int sbLength,byte sbBuffer[]) throws IOException;

	public boolean	acceptDo(int option);
	public boolean  acceptWill(int option);
	public boolean  acceptWont(int option);
	public boolean  acceptDont(int option);
	
}
